/*
 *	spPluginMain.h
 */

#ifndef __SPMAIN_H
#define __SPMAIN_H

#ifdef _WIN32
#include <windows.h>
#include <stdio.h>
#endif

#include <sp/spPluginP.h>

#ifdef __cplusplus
extern "C" {
#endif

#if defined(_WIN32)
#if defined(__CYGWIN32__)

#ifdef USE_CYGWIN32_DLL
#include <cygwin32/cygwin_dll.h>
#include <cygwin32/version.h>
#else
#include <cygwin/cygwin_dll.h>
#include <cygwin/version.h>
#endif

#if CYGWIN_VERSION_DLL_MAJOR <= 1001
BOOL WINAPI DllEntry(HANDLE hModule, DWORD reason, void *lpReserved)
{
    spSetHInstanceWin(hModule, reason);
    return TRUE;
}
#else
int WINAPI DllEntry(HINSTANCE hModule, DWORD reason, void *lpReserved)
{
    spSetHInstanceWin(hModule, reason);
    return TRUE;
}
#endif

DECLARE_CYGWIN_DLL(DllEntry)
#else  /* defined(__CYGWIN32__) */
BOOL WINAPI DllMain(HANDLE hModule, DWORD reason, LPVOID lpReserved)
{
    spSetHInstanceWin(hModule, reason);
    spsetstdio(stdin, stdout, stderr);
    return TRUE;
}
#endif /* !defined(__CYGWIN32__) */
#endif /* defined(_WIN32) */

#define SP_DECLARE_GET_PLUGIN_REC(recaddr)              \
    spPluginExport spPluginRec *spGetPluginRec(void) {  \
        return (spPluginRec *)(recaddr);                \
    }

#if defined(IPHONE)

#define SP_DECLARE_UNIQUE_GET_PLUGIN_REC(unique_id)                     \
    spUniquePluginExport spPluginRec *spGetPluginRec_ ## unique_id (long *system_version_id, long *supported_version_id) { \
        *system_version_id = SP_PLUGIN_SUPPORTED_VERSION_ID;            \
        *supported_version_id = SP_PLUGIN_SUPPORTED_VERSION_ID;         \
        return spGetPluginRec();                                        \
    }

#else /* defined(IPHONE) */
#if defined(MACOS)
#pragma export on
long spPluginSystemVersion(void);
long spPluginSupportedVersion(void);
spPluginRec *spGetPluginRec(void);
#pragma export off
#endif

spPluginExport long spPluginSystemVersion(void)
{
    return SP_PLUGIN_VERSION_ID;
}

spPluginExport long spPluginSupportedVersion(void)
{
    return SP_PLUGIN_SUPPORTED_VERSION_ID;
}

#define SP_DECLARE_UNIQUE_GET_PLUGIN_REC(id)

#endif /* !defined(IPHONE) */

spPluginExport spPluginRec *spGetPluginRec(void);

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPMAIN_H */
